---
title: 'Window: unhandledrejection event'
slug: Web/API/Window/unhandledrejection_event
tags:
  - API
  - Event
  - HTML DOM
  - JavaScript
  - Promise
  - Promises
  - Reference
  - Rejection
  - Window
  - Worker
  - events
  - global scope
  - unhandledrejection
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>unhandledrejection</code></strong> event is sent to the global scope of a script when a JavaScript {{jsxref("Promise")}} that has no rejection handler is rejected; typically, this is the {{domxref("window")}}, but may also be a {{domxref("Worker")}}.</span> This is useful for debugging and for providing fallback error handling for unexpected situations.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("PromiseRejectionEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("WindowEventHandlers.onunhandledrejection", "onunhandledrejection")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Usage_notes">Usage notes</h2>

<p>Allowing the <code>unhandledrejection</code> event to bubble will eventually result in an error message being output to the console. You can prevent this by calling {{domxref("Event.preventDefault", "preventDefault()")}} on the {{domxref("PromiseRejectionEvent")}}; see {{anch("Preventing default handling")}} below for an example.</p>

<h2 id="Examples">Examples</h2>

<p>Here we have a few examples showing ways you can make use of the <code>unhandledrejection</code> event. The event includes two useful pieces of information:</p>

<dl>
 <dt><code>promise</code></dt>
 <dd>The actual {{jsxref("Promise")}} which was rejected with no handler available to deal with the rejection.</dd>
 <dt><code>reason</code></dt>
 <dd>The reason that would have been passed into the rejection handler if one had existed. See {{jsxref("Promise.catch", "catch()")}} for details.</dd>
</dl>

<h3 id="Basic_error_logging">Basic error logging</h3>

<p>This example logs information about the unhandled promise rejection to the console.</p>

<pre class="brush:js; notranslate">window.addEventListener("unhandledrejection", event =&gt; {
  console.warn(`UNHANDLED PROMISE REJECTION: ${event.reason}`);
});
</pre>

<p>You can also use the {{domxref("WindowEventHandlers.onunhandledrejection", "onunhandledrejection")}} event handler property to set up the event listener:</p>

<pre class="brush: js notranslate">window.onunhandledrejection = event =&gt; {
  console.warn(`UNHANDLED PROMISE REJECTION: ${event.reason}`);
};
</pre>

<h3 id="Preventing_default_handling">Preventing default handling</h3>

<p>Many environments (such as {{Glossary("Node.js")}}) report unhandled promise rejections to the console by default. You can prevent that from happening by adding a handler for <code>unhandledrejection</code> events that—in addition to any other tasks you wish to perform—calls {{domxref("Event.preventDefault()", "preventDefault()")}} to cancel the event, preventing it from bubbling up to be handled by the runtime's logging code. This works because <code>unhandledrejection</code> is cancelable.</p>

<pre class="brush:js; notranslate">window.addEventListener('unhandledrejection', function (event) {
  // ...your code here to handle the unhandled rejection...

  // Prevent the default handling (such as outputting the
  // error to the console)

  event.preventDefault();
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#unhandled-promise-rejections', 'unhandledrejection')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.unhandledrejection_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{SectionOnPage("/en-US/docs/Web/JavaScript/Guide/Using_promises", "Promise rejection events")}}</li>
 <li>{{domxref("WindowEventHandlers.onunhandledrejection", "onunhandledrejection")}} event handler property<sup><a href="#seealso-footnote-1">1</a></sup></li>
 <li>{{domxref("Window/rejectionhandled_event", "rejectionhandled")}} event</li>
 <li>{{jsxref("Promise")}}</li>
</ul>

<p><a id="seealso-footnote-1">[1]</a> The corresponding event handler property is defined on the {{domxref("WindowEventHandlers")}} mixin, which is available on both the {{domxref("Window")}} interface and all types of {{domxref("Worker")}} interfaces.</p>
